#ifndef DATEVIEWHANDLER_H
#define DATEVIEWHANDLER_H
#include <qdatetime.h>
#include <qstring.h>
#include "imagedaterangecollection.h"

const int tickWidth = 15;

class DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate ) = 0;
    virtual bool isMajorUnit( int unit ) = 0;
    virtual bool isMidUnit( int unit );
    virtual QString text( int unit ) = 0;
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() ) = 0;

protected:
    QDateTime _startDate;
};


class DecadeViewHandler :public DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate );
    virtual bool isMajorUnit( int unit );
    virtual bool isMidUnit( int unit );
    virtual QString text( int unit );
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() );
};

class YearViewHandler :public DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate );
    virtual bool isMajorUnit( int unit );
    virtual bool isMidUnit( int unit );
    virtual QString text( int unit );
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() );
};

class MonthViewHandler :public DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate );
    virtual bool isMajorUnit( int unit );
    virtual QString text( int unit );
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() );
};

class WeekViewHandler :public DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate );
    virtual bool isMajorUnit( int unit );
    virtual QString text( int unit );
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() );
};

class DayViewHandler :public DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate );
    virtual bool isMajorUnit( int unit );
    virtual bool isMidUnit( int unit );
    virtual QString text( int unit );
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() );
};

class HourViewHandler :public DateViewHandler
{
public:
    virtual void init( const QDateTime& startDate );
    virtual bool isMajorUnit( int unit );
    virtual bool isMidUnit( int unit );
    virtual QString text( int unit );
    virtual QDateTime date(int unit, QDateTime reference = QDateTime() );
};


#endif /* DATEVIEWHANDLER_H */

