#include "imagedaterangecollection.h"
void ImageDateRangeCollection::append( const ImageDateRange& dateRange )
{
    _dates.append( dateRange );
}

ImageCount ImageDateRangeCollection::count( const ImageDate& from, const ImageDate& to )
{
    ImageDateRange range( from, to );
    if ( _cache.contains( range ) )
        return _cache[range];

    int exact = 0, rangeMatch = 0;
    for( QValueList<ImageDateRange>::Iterator it = _dates.begin(); it != _dates.end(); ++it ) {
        ImageDateRange::MatchType tp = (*it).includes( ImageDateRange( from, to ) );
        switch (tp) {
        case ImageDateRange::ExactMatch: exact++;break;
        case ImageDateRange::RangeMatch: rangeMatch++; break;
        case ImageDateRange::DontMatch: break;
        }
    }

    ImageCount res( exact, rangeMatch );
    _cache.insert( range, res );
    return res;
}
