#include <qapplication.h>
#include "datebar.h"
#include <qlayout.h>
#include <qvbuttongroup.h>
#include <qradiobutton.h>
#include <qdatetimeedit.h>
#include <qlabel.h>
#include <qfile.h>
#include <qtextstream.h>
#include "imagedaterangecollection.h"


int main( int argc, char** argv ) {
    QApplication app( argc, argv );

    DateBar* bar = new DateBar( 0 );
    ImageDateRangeCollection datelist;
    ImageDate date1;
    ImageDate date2;
    QFile file( "data" );
    Q_ASSERT( file.open(IO_ReadOnly) );
    QTextStream stream( &file );
    while ( !stream.atEnd() ) {
        QString line = stream.readLine();
        if ( !line.isEmpty() ) {
            QStringList list = QStringList::split( ' ', line );
            int yearFrom = list[0].toInt();
            int monthFrom = list[1].toInt();
            int dayFrom = list[2].toInt();
            int hourFrom = list[3].toInt();
            int  minuteFrom = list[4].toInt();
            int secondFrom = list[5].toInt();
            int yearTo = list[6].toInt();
            int monthTo = list [7].toInt();
            int dayTo = list[8].toInt();
            date1 = ImageDate( dayFrom, monthFrom, yearFrom );
            date1.setHour( hourFrom );
            date1.setMinute( minuteFrom );
            date1.setSecond( secondFrom );
            date2 = ImageDate( dayTo, monthTo, yearTo );
            datelist.append( ImageDateRange( date1, date2 ) );
            // qDebug("%s->%s", date1.min().toString().latin1(), date2.max().toString().latin1() );
        }
    }
    bar->setData( datelist );
    bar->show();

    QObject::connect( qApp, SIGNAL( lastWindowClosed() ), qApp, SLOT( quit() ) );
    return app.exec();
}

#include "main.moc"
